unit Score;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Utility, ExtCtrls, IniFiles, SysUtils, Odlist, Dialogs;

const

  SEC = 'ASTEROID DUEL';

type
  TfrmScores = class(TForm)
    lbScore: TOwnerDrawListBox;
    Header1: THeader;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lbScoreDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
  private
  public
    ini: TIniFile;
    arScores: array[1..10] of longint;
    procedure CheckHighScore( n: longint; const s: string );
  end;

var
  frmScores: TfrmScores;

implementation

{$R *.DFM}

procedure TfrmScores.FormCreate(Sender: TObject);
var
  ini: TIniFile;
  i: integer;
begin
  ini := TIniFile.Create( 'SILCMD.INI' );
  for i := 1 to 10 do
     begin
        arScores[i] := ini.ReadInteger( SEC, 'Score' + IntToStr( i ), 0 );
        lbScore.Items.Add( ini.ReadString( SEC, 'Line' + IntToStr( i ),
           '999999999;0;???;???' ) );
     end;
  ini.Free;
end;

procedure TfrmScores.FormDestroy(Sender: TObject);
var
  i: integer;
begin
  ini := TIniFile.Create( 'SILCMD.INI' );
  for i := 1 to 10 do
     begin
        ini.WriteInteger( SEC, 'Score' + IntToStr( i ), arScores[i] );
        ini.WriteString( SEC, 'Line' + IntToStr( i ), lbScore.Items[i - 1] );
     end;
  ini.Free;
end;

procedure TfrmScores.CheckHighScore( n: longint; const s: string );
var
  i: integer;
  sItem, sName, sLine: string;
begin
  for i := 1 to 10 do
     if n > arScores[i] then
        begin
           sName := InputBox( 'Player ' + s, 'Enter your Name:', '???' );
           sLine := IntToStr( 999999999 - n ) + ';' + IntToStr( n ) + ';' + sName + ';' + DateToStr( Date );
           lbScore.Items.Add( sLine );
           for i := 1 to 10 do
              begin
                 sItem := lbScore.Items[i - 1];
                 GetToken( sItem, ';' );
                 arScores[i] := StrToInt( GetToken( sItem, ';' ) );
              end;
           Exit;
        end;
end;

procedure TfrmScores.lbScoreDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  sItem: string;
begin
  sItem := lbScore.Items[Index];
  GetToken( sItem, ';' );
  with lbScore.Canvas do
     begin
        TextOut( Rect.Left, Rect.Top, GetToken( sItem, ';' ) );
        TextOut( Rect.Left + 120, Rect.Top, GetToken( sItem, ';' ) );
        TextOut( Rect.Left + 170, Rect.Top, sItem );
     end;
end;

end.
